﻿# VERSION 2 avec l'approche de seconde Vx environ égale à x(t+1)-x(t)/Δt
# ##########################################################################
# Programme Python permettant de tracer les positions d'un point M
# à partir d'abscisses et d'ordonnées issues d'un pointage (ou d'équations).
# et de tracer le vecteur vitesse en un point
# à destination des élèves qui peuvent modifier le code sous les parties roses

# L'utilisation des listes NUMPY permet de simplifier le code
# ##########################################################################
# O. CHAUMETTE - Lycée JP SARTRE - 69500 BRON - olivier.chaumette@ac-lyon.fr
# ##########################################################################


# ##########################
# IMPORTATION DES MODULES #
# #########################
# importation de NUMPY (pour gestion tableaux et calculs) sous l'alias "np"
import numpy as np
# importation de PYPLOT (du module MATPLOTLIB, pour le tracé de courbes) sous l'alias "plt"
import matplotlib.pyplot as plt

# modules permettant d'importer des données
# le fichier "import_donnees.py" est indispensable
from import_donnees_meca import traiteDonnees


# Initialisation des tableaux numpy contenant x,y,t
x=np.array([])
y=np.array([])
t=np.array([])


# #################################
# Fonction qui simplifie le tracé du vecteur vitesse
# afin que l'élève n'ait pas à définir l'origine
# du vecteur en termes de coordonnées
# (pour ne pas mélanger des positions et des coordonées de vecteurs)
# #################################
def draw_Vector(numero_du_point, abscisse_vecteur, ordonnee_vecteur, couleur):
    global x,y
    plt.quiver(x[numero_du_point], y[numero_du_point],abscisse_vecteur,ordonnee_vecteur,color=couleur,scale=30)


""" ---------------------------------
        CHOIX du PROFESSEUR
------------------------------------- """
#  Logiciel utilisé à choisir parmi :
# 'pymecavideo'     (exporter un fichier TXT)
# 'latispro'        (fichier TXT créé par LATISPRO, avec décimale VIRGULE et séparation POINT VIRGULE)
# 'avimeca'         (crééer un fichier TXT en export)
# 'avistep'         (pointage exporté depuis AVISTEP:
# 'equation'        (équation paramétrées saisies dans le fichier "import_donnees")
# 'entrees'        (données de pointage saisies "à la main" dans le fichier "import_donnees.py)

Logiciel_Utilise = 'latispro'

""" ---------------------------------
        FIN du CHOIX du PROFESSEUR
------------------------------------- """

t, x, y = traiteDonnees(Logiciel_Utilise)




""" ###########################################
Ici commence le travail à réaliser par les élèves
################################################# """
# #####################################
# Tracé de la trajectoire
# #####################################
""" TRAVAIL 1:
Taper ci-dessous le code Python permettant de tracer l'ordonnée du point en fonction de son abscisse. """
plt.plot(x,y,"+r")


""" TRAVAIL 2:
taper, à la place des points entre guillemets, les légendes pour les axes,
le titre du graphique"""
plt.title("Trajectoire du point point M")          # titre du graphique
plt.xlabel("Abscisse X du système (en m)")         # nom de la grandeur sur l'axe X
plt.ylabel("Ordonnée Y du système (en m)")         # nom de la grandeur sur l'axe Y


""" TRAVAIL 3:
Taper ci-dessous le code python permettant:
    - de mettre dans une variable Vx l'abscisse du vecteur vitesse au point 5
    - de mettre dans une variable Vy l'ordonnée du vecteur vitesse au point 5 """
Vx = (x[6]-x[5])/(t[6]-t[5])
Vy = (y[6]-y[5])/(t[6]-t[5])


""" TRAVAIL 4:
Taper ci-dessous le code python permettant
de tracer le vecteur vitesse au point 5 en bleu"""
draw_Vector(5,Vx,Vy,"b")


""" TRAVAIL 5:
    Généralisation
Taper ci-dessous le code python permettant:
    - créer une variable nommée n correspondant à un numéro de point quelconque (3 par exemple)
    - de mettre dans une variable Vx l'abscisse du vecteur vitesse au point n
    - de mettre dans une variable Vy l'ordonnée du vecteur vitesse au point n
    - de tracer le vecteur vitesse au point n en vert"""
n=10
Vx = (x[n+1]-x[n])/(t[n+1]-t[n])
Vy = (y[n+1]-y[n])/(t[n+1]-t[n])
draw_Vector(n,Vx,Vy,"g")


""" fin du travail """


# On affiche une grille
plt.grid()
# le repère doit être orthonormé:
plt.axis('equal')
# on affiche la fenêtre
#plt.get_current_fig_manager().window.state('zoomed')   # <-- Affiche la fenêtre maximisée sous windows uniquement
plt.show()
